diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index 9d95c5301d..3d8c087b81 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -229,6 +229,12 @@ static const char *const backend_options = "--single -F -O -j -c search_path=pg_
 /* Additional switches to pass to backend (either boot or standalone) */
 static char *extra_options = "";
 
+/*
+ * The cluster subdirectories created here are mirrored by
+ * SynthesizeUpgradeStreamControlFile() in xlog.c, which builds a bare skeleton
+ * for a --wal-upgrade streaming standby without running initdb.  Keep the two
+ * lists in sync: a new required subdir added here must be added there too.
+ */
 static const char *const subdirs[] = {
 	"global",
 	"pg_wal/archive_status",
diff --git a/src/bin/pg_controldata/pg_controldata.c b/src/bin/pg_controldata/pg_controldata.c
index fe5fc5ec13..0484582e75 100644
--- a/src/bin/pg_controldata/pg_controldata.c
+++ b/src/bin/pg_controldata/pg_controldata.c
@@ -65,6 +65,8 @@ dbState(DBState state)
 			return _("in archive recovery");
 		case DB_IN_PRODUCTION:
 			return _("in production");
+		case DB_IN_UPGRADE:
+			return _("in pg_upgrade");
 	}
 	return _("unrecognized status code");
 }
@@ -349,6 +351,8 @@ main(int argc, char *argv[])
 		   ControlFile->data_checksum_version);
 	printf(_("Default char data signedness:         %s\n"),
 		   (ControlFile->default_char_signedness ? _("signed") : _("unsigned")));
+	printf(_("wal-upgrade window finalized:         %s\n"),
+		   (ControlFile->upgrade_finalized ? _("yes") : _("no")));
 	printf(_("Mock authentication nonce:            %s\n"),
 		   mock_auth_nonce_str);
 	return 0;
diff --git a/src/bin/pg_ctl/pg_ctl.c b/src/bin/pg_ctl/pg_ctl.c
index 7dc6e1ad8f..1f3daf14f0 100644
--- a/src/bin/pg_ctl/pg_ctl.c
+++ b/src/bin/pg_ctl/pg_ctl.c
@@ -269,6 +269,23 @@ get_pgpid(bool is_status_request)
 
 	if (stat(version_file, &statbuf) != 0 && errno == ENOENT)
 	{
+		char		sigpath[MAXPGPATH];
+		struct stat sigbuf;
+
+		/*
+		 * A --wal-upgrade streaming standby may be staged without initdb -- a
+		 * bare directory carrying only config plus the pg_upgrade.signal
+		 * sentinel.  PG_VERSION does not exist yet; the postmaster
+		 * synthesizes it (and pg_control) on start.  So if the sentinel is
+		 * present, do NOT reject the directory here -- there is simply no
+		 * server running yet, so report "no pid" (0) exactly as for a normal
+		 * not-yet-started cluster and let do_start() launch the postmaster,
+		 * which does the synthesis.
+		 */
+		snprintf(sigpath, sizeof(sigpath), "%s/pg_upgrade.signal", pg_data);
+		if (stat(sigpath, &sigbuf) == 0)
+			return 0;
+
 		write_stderr(_("%s: directory \"%s\" is not a database cluster directory\n"),
 					 progname, pg_data);
 		exit(is_status_request ? 4 : 1);
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index f8d25afed9..5d6e41662e 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -97,6 +97,15 @@ static int	wal_segsize_val;
 static bool char_signedness_given = false;
 static bool char_signedness_val;
 
+/*
+ * --wal-upgrade-exact: make the -l/--next-wal-file target authoritative so the
+ * new WAL start position can be forced DOWN (not just floored upward over the
+ * existing pg_wal/ segments and the current checkpoint).  Intended for internal
+ * use by "pg_upgrade --wal-upgrade", which must land the end-of-upgrade
+ * checkpoint (CN) at a byte-deterministic segment boundary.
+ */
+static bool wal_upgrade_exact = false;
+
 
 static TimeLineID minXlogTli = 0;
 static XLogSegNo minXlogSegNo = 0;
@@ -135,6 +144,7 @@ main(int argc, char *argv[])
 		{"next-transaction-id", required_argument, NULL, 'x'},
 		{"wal-segsize", required_argument, NULL, 1},
 		{"char-signedness", required_argument, NULL, 2},
+		{"wal-upgrade-exact", no_argument, NULL, 3},
 		{NULL, 0, NULL, 0}
 	};
 
@@ -352,6 +362,10 @@ main(int argc, char *argv[])
 					break;
 				}
 
+			case 3:
+				wal_upgrade_exact = true;
+				break;
+
 			default:
 				/* getopt_long already emitted a complaint */
 				pg_log_error_hint("Try \"%s --help\" for more information.", progname);
@@ -378,6 +392,13 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 
+	/*
+	 * --wal-upgrade-exact makes the -l target authoritative, so it is
+	 * meaningless (and almost certainly a mistake) without -l.
+	 */
+	if (wal_upgrade_exact && log_fname == NULL)
+		pg_fatal("option --wal-upgrade-exact requires -l/--next-wal-file");
+
 	/*
 	 * Don't allow pg_resetwal to be run as root, to avoid overwriting the
 	 * ownership of files in the data directory. We need only check for root
@@ -510,7 +531,18 @@ main(int argc, char *argv[])
 	if (char_signedness_given)
 		ControlFile.default_char_signedness = char_signedness_val;
 
-	if (minXlogSegNo > newXlogSegNo)
+	if (wal_upgrade_exact)
+	{
+		/*
+		 * The -l target is authoritative: force the new WAL start to exactly
+		 * that segment, overriding the FindEndOfXLOG floor.  This is the only
+		 * way to move the position DOWN (below the current checkpoint / the
+		 * highest existing pg_wal/ segment), which pg_upgrade --wal-upgrade
+		 * needs to land CN at a byte-deterministic boundary.
+		 */
+		newXlogSegNo = minXlogSegNo;
+	}
+	else if (minXlogSegNo > newXlogSegNo)
 		newXlogSegNo = minXlogSegNo;
 
 	if (noupdate)
@@ -1239,6 +1271,14 @@ usage(void)
 	printf(_("      --char-signedness=OPTION     set char signedness to \"signed\" or \"unsigned\"\n"));
 	printf(_("      --wal-segsize=SIZE           size of WAL segments, in megabytes\n"));
 
+	/*
+	 * --wal-upgrade-exact is intentionally NOT listed here: it is an internal
+	 * implementation detail of pg_upgrade --wal-upgrade (it forces the -l
+	 * target downward so the end-of-upgrade checkpoint lands at a
+	 * byte-deterministic boundary), not a user-facing option.  Kept
+	 * undocumented like other binary-upgrade-only machinery.
+	 */
+
 	printf(_("\nReport bugs to <%s>.\n"), PACKAGE_BUGREPORT);
 	printf(_("%s home page: <%s>\n"), PACKAGE_NAME, PACKAGE_URL);
 }
diff --git a/src/bin/pg_upgrade/Makefile b/src/bin/pg_upgrade/Makefile
index 771addb675..e37097bcc3 100644
--- a/src/bin/pg_upgrade/Makefile
+++ b/src/bin/pg_upgrade/Makefile
@@ -24,6 +24,7 @@ OBJS = \
 	parallel.o \
 	pg_upgrade.o \
 	relfilenumber.o \
+	revertable.o \
 	server.o \
 	slru_io.o \
 	tablespace.o \
diff --git a/src/bin/pg_upgrade/check.c b/src/bin/pg_upgrade/check.c
index 2155b01b11..5f08315e90 100644
--- a/src/bin/pg_upgrade/check.c
+++ b/src/bin/pg_upgrade/check.c
@@ -560,6 +560,14 @@ check_and_dump_old_cluster(void)
 	 */
 	get_db_rel_and_slot_infos(&old_cluster);
 
+	/*
+	 * On the --wal-upgrade path, also gather the old cluster's physical
+	 * replication slots so they can be recreated on the new cluster (see
+	 * get_old_cluster_physical_slot_infos).  Must run while the old server is
+	 * up.
+	 */
+	get_old_cluster_physical_slot_infos();
+
 	init_tablespaces();
 
 	get_loadable_libraries();
@@ -760,6 +768,12 @@ output_completion_banner(char *deletion_script_file_name)
 		appendPQExpBufferChar(&user_specification, ' ');
 	}
 
+	/* report WAL generated during pg_restore (only for --wal-upgrade) */
+	if (user_opts.wal_upgrade)
+		pg_log(PG_REPORT,
+			   "WAL generated during schema restore: " UINT64_FORMAT " bytes",
+			   log_opts.pg_upgrade_wal_bytes);
+
 	pg_log(PG_REPORT,
 		   "Some statistics are not transferred by pg_upgrade.\n"
 		   "Once you start the new server, consider running these two commands:\n"
@@ -2061,6 +2075,39 @@ check_new_cluster_replication_slots(void)
 	int			i_nslots_on_new;
 	int			i_rdt_slot_on_new;
 
+	/*
+	 * --wal-upgrade migrates the old cluster's physical replication slots and
+	 * recreates them on the new cluster (see
+	 * get_old_cluster_physical_slot_infos / pg_upgrade.c).  Each recreation
+	 * needs a free slot, so the new cluster's max_replication_slots must
+	 * accommodate them.  This is independent of the logical-slot /
+	 * retain_dead_tuples machinery below (which early-returns when there are
+	 * no logical slots and is gated on PG17+), so check it up front and for
+	 * any old major.  Recreation is otherwise best-effort (warn-not-fail), so
+	 * without this a too-small max_replication_slots would silently migrate
+	 * fewer physical slots than expected and quietly break those standbys'
+	 * streaming.
+	 */
+	if (user_opts.wal_upgrade && old_cluster.phys_slot_arr.nslots > 0)
+	{
+		PGconn	   *pconn = connectToServer(&new_cluster, "template1");
+		PGresult   *pres = executeQueryOrDie(pconn,
+											 "SELECT setting FROM pg_settings "
+											 "WHERE name = 'max_replication_slots'");
+		int			max_slots;
+
+		if (PQntuples(pres) != 1)
+			pg_fatal("could not determine \"max_replication_slots\" on the new cluster");
+		max_slots = atoi(PQgetvalue(pres, 0, 0));
+		PQclear(pres);
+		PQfinish(pconn);
+
+		if (old_cluster.phys_slot_arr.nslots > max_slots)
+			pg_fatal("\"max_replication_slots\" (%d) must be greater than or equal to the number of "
+					 "physical replication slots (%d) in the old cluster migrated by --wal-upgrade",
+					 max_slots, old_cluster.phys_slot_arr.nslots);
+	}
+
 	/*
 	 * Logical slots can be migrated since PG17 and a physical slot
 	 * CONFLICT_DETECTION_SLOT can be migrated since PG19.
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
index 02ea02df60..4b111d7ee6 100644
--- a/src/bin/pg_upgrade/controldata.c
+++ b/src/bin/pg_upgrade/controldata.c
@@ -75,6 +75,15 @@ get_control_data(ClusterInfo *cluster)
 	int			rc;
 	bool		live_check = (cluster == &old_cluster && user_opts.live_check);
 
+	/*
+	 * With --initdb the old cluster's control data is read early, to derive
+	 * initdb options, before the normal call in
+	 * check_cluster_compatibility(). A non-zero ctrl_ver means it has already
+	 * been read; don't repeat it.
+	 */
+	if (cluster->controldata.ctrl_ver != 0)
+		return;
+
 	/*
 	 * Because we test the pg_resetwal output as strings, it has to be in
 	 * English.  Copied from pg_regress.c.
diff --git a/src/bin/pg_upgrade/file.c b/src/bin/pg_upgrade/file.c
index af82c0de49..9c93b51e3f 100644
--- a/src/bin/pg_upgrade/file.c
+++ b/src/bin/pg_upgrade/file.c
@@ -21,6 +21,7 @@
 #endif
 
 #include "common/file_perm.h"
+#include "common/file_utils.h"
 #include "pg_upgrade.h"
 
 
@@ -35,36 +36,17 @@ void
 cloneFile(const char *src, const char *dst,
 		  const char *schemaName, const char *relName)
 {
-#if defined(HAVE_COPYFILE) && defined(COPYFILE_CLONE_FORCE)
-	if (copyfile(src, dst, NULL, COPYFILE_CLONE_FORCE) < 0)
-		pg_fatal("error while cloning relation \"%s.%s\" (\"%s\" to \"%s\"): %m",
-				 schemaName, relName, src, dst);
-#elif defined(__linux__) && defined(FICLONE)
-	int			src_fd;
-	int			dest_fd;
-
-	if ((src_fd = open(src, O_RDONLY | PG_BINARY, 0)) < 0)
-		pg_fatal("error while cloning relation \"%s.%s\": could not open file \"%s\": %m",
-				 schemaName, relName, src);
-
-	if ((dest_fd = open(dst, O_RDWR | O_CREAT | O_EXCL | PG_BINARY,
-						pg_file_create_mode)) < 0)
-		pg_fatal("error while cloning relation \"%s.%s\": could not create file \"%s\": %m",
-				 schemaName, relName, dst);
+	int			save_errno;
 
-	if (ioctl(dest_fd, FICLONE, src_fd) < 0)
+	switch (pg_clone_file(src, dst, &save_errno))
 	{
-		int			save_errno = errno;
-
-		unlink(dst);
-
-		pg_fatal("error while cloning relation \"%s.%s\" (\"%s\" to \"%s\"): %s",
-				 schemaName, relName, src, dst, strerror(save_errno));
+		case PG_REFLINK_OK:
+		case PG_REFLINK_UNSUPPORTED:
+			break;
+		case PG_REFLINK_ERROR:
+			pg_fatal("error while cloning relation \"%s.%s\" (\"%s\" to \"%s\"): %s",
+					 schemaName, relName, src, dst, strerror(save_errno));
 	}
-
-	close(src_fd);
-	close(dest_fd);
-#endif
 }
 
 
@@ -147,32 +129,17 @@ void
 copyFileByRange(const char *src, const char *dst,
 				const char *schemaName, const char *relName)
 {
-#ifdef HAVE_COPY_FILE_RANGE
-	int			src_fd;
-	int			dest_fd;
-	ssize_t		nbytes;
-
-	if ((src_fd = open(src, O_RDONLY | PG_BINARY, 0)) < 0)
-		pg_fatal("error while copying relation \"%s.%s\": could not open file \"%s\": %m",
-				 schemaName, relName, src);
-
-	if ((dest_fd = open(dst, O_RDWR | O_CREAT | O_EXCL | PG_BINARY,
-						pg_file_create_mode)) < 0)
-		pg_fatal("error while copying relation \"%s.%s\": could not create file \"%s\": %m",
-				 schemaName, relName, dst);
+	int			save_errno;
 
-	do
+	switch (pg_copy_file_range_all(src, dst, &save_errno))
 	{
-		nbytes = copy_file_range(src_fd, NULL, dest_fd, NULL, SSIZE_MAX, 0);
-		if (nbytes < 0)
-			pg_fatal("error while copying relation \"%s.%s\": could not copy file range from \"%s\" to \"%s\": %m",
-					 schemaName, relName, src, dst);
+		case PG_REFLINK_OK:
+		case PG_REFLINK_UNSUPPORTED:
+			break;
+		case PG_REFLINK_ERROR:
+			pg_fatal("error while copying relation \"%s.%s\": could not copy file range from \"%s\" to \"%s\": %s",
+					 schemaName, relName, src, dst, strerror(save_errno));
 	}
-	while (nbytes > 0);
-
-	close(src_fd);
-	close(dest_fd);
-#endif
 }
 
 
diff --git a/src/bin/pg_upgrade/info.c b/src/bin/pg_upgrade/info.c
index 37fff93892..8a69148dd5 100644
--- a/src/bin/pg_upgrade/info.c
+++ b/src/bin/pg_upgrade/info.c
@@ -21,7 +21,6 @@ static void create_rel_filename_map(const char *old_data, const char *new_data,
 static void report_unmatched_relation(const RelInfo *rel, const DbInfo *db,
 									  bool is_new_db);
 static void free_db_and_rel_infos(DbInfoArr *db_arr);
-static void get_template0_info(ClusterInfo *cluster);
 static void get_db_infos(ClusterInfo *cluster);
 static char *get_rel_infos_query(void);
 static void process_rel_infos(DbInfo *dbinfo, PGresult *res, void *arg);
@@ -328,7 +327,7 @@ get_db_rel_and_slot_infos(ClusterInfo *cluster)
  * Get information about template0, which will be copied from the old cluster
  * to the new cluster.
  */
-static void
+void
 get_template0_info(ClusterInfo *cluster)
 {
 	PGconn	   *conn = connectToServer(cluster, "template1");
@@ -832,6 +831,90 @@ count_old_cluster_logical_slots(void)
 	return slot_count;
 }
 
+/*
+ * get_old_cluster_physical_slot_infos()
+ *
+ * Gather the old cluster's physical replication slots so --wal-upgrade can
+ * recreate them on the new cluster.  Stock pg_upgrade does NOT migrate physical
+ * slots: before --wal-upgrade a standby could not follow the upgrade at all
+ * (it was rebuilt from scratch), so its slot was pointless to carry.  With
+ * --wal-upgrade the standby follows by streaming the upgrade window, so its
+ * slot becomes meaningful across the boundary -- migrating it preserves both
+ * the standby's slot identity (HA tooling / primary_slot_name keep working)
+ * and, because the recreated slot is reserved before CN, the window retention
+ * itself.  It is the only slot that pins the window; with no physical slot,
+ * --wal-upgrade has no streaming consumer and the window is not pinned.
+ *
+ * Physical slots are cluster-wide (not database-scoped) and carry no decoding
+ * state, so a single query over pg_replication_slots suffices.  Temporary and
+ * invalidated ("lost") slots are skipped: temporary slots cannot survive the
+ * start/stop cycles of the upgrade, and an invalidated slot has no usable
+ * restart_lsn to recreate.  Assumes the old server is running.
+ */
+void
+get_old_cluster_physical_slot_infos(void)
+{
+	PGconn	   *conn;
+	PGresult   *res;
+	PhysicalSlotInfo *slotinfos = NULL;
+	int			num_slots;
+
+	old_cluster.phys_slot_arr.slots = NULL;
+	old_cluster.phys_slot_arr.nslots = 0;
+
+	/* Only relevant to --wal-upgrade. */
+	if (!user_opts.wal_upgrade)
+		return;
+
+	conn = connectToServer(&old_cluster, "template1");
+
+	/*
+	 * Skip invalidated slots so we do not try to recreate a dead one.  The
+	 * pg_replication_slots.invalidation_reason column only exists in PG17+,
+	 * so gate the predicate on the old cluster's version -- otherwise the
+	 * query would error on an older major and abort the whole upgrade.  On
+	 * older majors we simply enumerate all physical slots; recreation below
+	 * is best-effort and warns rather than fails, so a slot that turns out to
+	 * be unusable does not stop the upgrade.
+	 *
+	 * Exclude the internal "pg_conflict_detection" slot: since PG19 the
+	 * conflict-detection slot for retain_dead_tuples subscriptions is a
+	 * cluster-wide (physical) slot, so it shows up here, but its name is
+	 * reserved -- pg_create_physical_replication_slot() rejects it -- and
+	 * pg_upgrade recreates it separately via its own path.  Migrating it here
+	 * would only emit a spurious warning and, if it were the sole physical
+	 * slot, make us believe a standby consumer exists (and try to pin the
+	 * window) when none does.
+	 */
+	res = executeQueryOrDie(conn,
+							"SELECT slot_name "
+							"FROM pg_catalog.pg_replication_slots "
+							"WHERE slot_type = 'physical' AND "
+							"temporary IS FALSE AND "
+							"slot_name <> 'pg_conflict_detection'%s",
+							GET_MAJOR_VERSION(old_cluster.major_version) >= 1700 ?
+							" AND invalidation_reason IS NULL" : "");
+
+	num_slots = PQntuples(res);
+
+	if (num_slots)
+	{
+		int			i_slotname = PQfnumber(res, "slot_name");
+
+		slotinfos = pg_malloc_array(PhysicalSlotInfo, num_slots);
+
+		for (int slotnum = 0; slotnum < num_slots; slotnum++)
+			slotinfos[slotnum].slotname =
+				pg_strdup(PQgetvalue(res, slotnum, i_slotname));
+	}
+
+	PQclear(res);
+	PQfinish(conn);
+
+	old_cluster.phys_slot_arr.slots = slotinfos;
+	old_cluster.phys_slot_arr.nslots = num_slots;
+}
+
 /*
  * get_subscription_info()
  *
diff --git a/src/bin/pg_upgrade/meson.build b/src/bin/pg_upgrade/meson.build
index ffbf6ae8d7..774bf46c78 100644
--- a/src/bin/pg_upgrade/meson.build
+++ b/src/bin/pg_upgrade/meson.build
@@ -14,6 +14,7 @@ pg_upgrade_sources = files(
   'parallel.c',
   'pg_upgrade.c',
   'relfilenumber.c',
+  'revertable.c',
   'server.c',
   'slru_io.c',
   'tablespace.c',
@@ -69,6 +70,9 @@ tests += {
       't/006_transfer_modes.pl',
       't/007_multixact_conversion.pl',
       't/008_extension_control_path.pl',
+      't/009_initdb_option.pl',
+      't/010_wal_upgrade.pl',
+      't/011_wal_upgrade_standby.pl',
     ],
     'deps': [test_ext],
     'test_kwargs': {'priority': 40}, # pg_upgrade tests are slow
diff --git a/src/bin/pg_upgrade/option.c b/src/bin/pg_upgrade/option.c
index f01d2f92d9..dd097f2be0 100644
--- a/src/bin/pg_upgrade/option.c
+++ b/src/bin/pg_upgrade/option.c
@@ -63,6 +63,12 @@ parseCommandLine(int argc, char *argv[])
 		{"no-statistics", no_argument, NULL, 5},
 		{"set-char-signedness", required_argument, NULL, 6},
 		{"swap", no_argument, NULL, 7},
+		{"initdb", no_argument, NULL, 8},
+		/* capture the upgrade as WAL and reconstruct it on first startup */
+		{"wal-upgrade", no_argument, NULL, 9},
+
+		/* --wal-upgrade lifecycle subcommand (acts on -d old) */
+		{"wal-upgrade-signal-handoff", no_argument, NULL, 14},
 
 		{NULL, 0, NULL, 0}
 	};
@@ -234,6 +240,20 @@ parseCommandLine(int argc, char *argv[])
 				user_opts.transfer_mode = TRANSFER_MODE_SWAP;
 				break;
 
+			case 8:
+				user_opts.initdb_new_cluster = true;
+				break;
+
+				/* --wal-upgrade */
+			case 9:
+				user_opts.wal_upgrade = true;
+				break;
+
+				/* --wal-upgrade lifecycle subcommand */
+			case 14:
+				user_opts.revertable_op = REVERTABLE_OP_SIGNAL_HANDOFF;
+				break;
+
 			default:
 				fprintf(stderr, _("Try \"%s --help\" for more information.\n"),
 						os_info.progname);
@@ -244,6 +264,31 @@ parseCommandLine(int argc, char *argv[])
 	if (optind < argc)
 		pg_fatal("too many command-line arguments (first is \"%s\")", argv[optind]);
 
+	/*
+	 * --check is read-only and may run against a live old cluster, while
+	 * --initdb creates the new cluster on disk.  Reject the combination.
+	 */
+	if (user_opts.check && user_opts.initdb_new_cluster)
+		pg_fatal("options %s and %s cannot be used together",
+				 "-c/--check", "--initdb");
+
+	/*
+	 * -O is accepted together with --initdb.  create_new_cluster_via_initdb()
+	 * derives initdb's core options from the old cluster's control data, then
+	 * appends -O (new_cluster.pgopts) to the initdb command line; the same -O
+	 * options are also passed to the new cluster's postmaster during the
+	 * server phases.  This is needed for --wal-upgrade -- e.g. "-c
+	 * allow_in_place_tablespaces=on" -- so it is not rejected.
+	 */
+
+	/*
+	 * --swap is compatible with --wal-upgrade.  The WAL window is generated
+	 * regardless of transfer mode, so standbys can still be reconstructed
+	 * from it.  --swap moves the old cluster's data directories into the new
+	 * cluster (do_swap); this is acceptable because --wal-upgrade offers no
+	 * revert-to-old interface that would depend on the old cluster surviving.
+	 */
+
 	if (!user_opts.sync_method)
 		user_opts.sync_method = pg_strdup("fsync");
 
@@ -264,6 +309,24 @@ parseCommandLine(int argc, char *argv[])
 	else
 		setenv("PGOPTIONS", FIX_DEFAULT_READ_ONLY, 1);
 
+	/*
+	 * --wal-upgrade-signal-handoff acts on a single existing (running) old
+	 * cluster and does not run an upgrade, so it needs only the old cluster's
+	 * data + bin directories, not the full old/new set the normal flow
+	 * requires. It connects to the LIVE old primary, writes the handoff
+	 * trigger into its WAL, and shuts the primary down at that point so no
+	 * transaction can append WAL after the handoff.  The old bin dir is
+	 * needed to run that cluster's pg_ctl for the shutdown.
+	 */
+	if (user_opts.revertable_op == REVERTABLE_OP_SIGNAL_HANDOFF)
+	{
+		if (old_cluster.pgdata == NULL)
+			pg_fatal("--wal-upgrade-signal-handoff requires the old cluster data directory (-d/--old-datadir)");
+		if (old_cluster.bindir == NULL)
+			pg_fatal("--wal-upgrade-signal-handoff requires the old cluster bin directory (-b/--old-bindir)");
+		return;
+	}
+
 	/* Get values from env if not already set */
 	check_required_directory(&old_cluster.bindir, "PGBINOLD", false,
 							 "-b", _("old cluster binaries reside"), false);
@@ -328,6 +391,14 @@ usage(void)
 	printf(_("  --clone                       clone instead of copying files to new cluster\n"));
 	printf(_("  --copy                        copy files to new cluster (default)\n"));
 	printf(_("  --copy-file-range             copy files to new cluster with copy_file_range\n"));
+	/* --wal-upgrade usage */
+	printf(_("  --wal-upgrade                 capture the whole upgrade as WAL and reconstruct\n"
+			 "                                the cluster from it on first startup (atomic,\n"
+			 "                                crash-safe, WAL-replayable)\n"));
+	printf(_("  --wal-upgrade-signal-handoff  signal streaming standbys to stand down for a\n"
+			 "                                --wal-upgrade, then shut the old primary down\n"));
+	printf(_("  --initdb                      create the new cluster with initdb before\n"
+			 "                                upgrading (settings derived from old cluster)\n"));
 	printf(_("  --no-statistics               do not import statistics from old cluster\n"));
 	printf(_("  --set-char-signedness=OPTION  set new cluster char signedness to \"signed\" or\n"
 			 "                                \"unsigned\"\n"));
@@ -336,7 +407,9 @@ usage(void)
 	printf(_("  -?, --help                    show this help, then exit\n"));
 	printf(_("\n"
 			 "Before running pg_upgrade you must:\n"
-			 "  create a new database cluster (using the new version of initdb)\n"
+			 "  create a new database cluster (using the new version of initdb),\n"
+			 "    unless the --initdb option is given, in which case pg_upgrade\n"
+			 "    creates the new cluster for you\n"
 			 "  shutdown the postmaster servicing the old cluster\n"
 			 "  shutdown the postmaster servicing the new cluster\n"));
 	printf(_("\n"
